
// source: stackoverflow
// use gcc -O2

#include <algorithm>
#include <ctime>
#include <iostream>

int main(int argc, char *argv[]) {
    // Generate data
    const unsigned arraySize = 32768;
    int data[arraySize];

    for (unsigned c = 0; c < arraySize; ++c)
        data[c] = std::rand() % 256;

    // !!! With this, the next loop runs faster
    if(argc>1) {
        std::cout << "sorted\n";
        std::sort(data, data + arraySize);
    }
    // Test
    clock_t start = clock();
    long long sum = 0;

    for (unsigned i = 0; i < 100000; ++i)
    {
        // Primary loop
        for (unsigned c = 0; c < arraySize; ++c)
        {
            if (data[c] >= 128)
                sum += data[c];
        }
    }

    double elapsedTime = static_cast<double>(clock() - start) / CLOCKS_PER_SEC;

    std::cout << "time= " << elapsedTime << " s\n";
    std::cout << "sum = " << sum << std::endl;
}
